package SpritesTool;

import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Point;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

import unit4.collectionsLib.Queue;

/**
 * 
 * @author samih <br>
 *                 
 * 
 */
public class Sprite implements Runnable
{

	private Queue<Image> frames;

	private int width, height;

	private String[] imgsNames;

	private Point loc;

	private Graphics2D offGraphics;

	JPanel observer;

	private long delay = 50;

	private boolean isRun = false;

	private Thread thread = null;

	public Sprite(String[] imgsNames, Graphics2D offGraphics, JPanel observer,
			int x, int y)
	{
		this.imgsNames = new String[imgsNames.length];
		this.frames = new Queue<Image>();
		this.observer = observer;
		this.offGraphics = offGraphics;
		this.loc = new Point(x, y);
		for (int i = 0; i < imgsNames.length; i++)
		{
			this.imgsNames[i] = imgsNames[i];
			this.frames.insert(new ImageIcon(this.imgsNames[i]).getImage());
			if (i == 0)
			{
				this.width = this.frames.head().getWidth(observer);
				this.height = this.frames.head().getHeight(observer);
			}
		}

		// nextFrame();

	}

	public void nextFrame()
	{
		// this.currentFrame = (this.currentFrame + 1) % frameAmount;
		frames.insert(frames.remove());
	}

	public void drawCurrentSprite()
	{
		offGraphics.drawImage(frames.head(), loc.x, loc.y, width, height,
				observer);
	}

	public void setLocation(int x, int y)
	{
		loc.x = x;
		loc.y = y;
	}

	public void animate(long delay)
	{
		if (delay > 0)
			this.delay = delay;
		if (thread == null)
		{
			thread = new Thread(this);
			isRun = true;
			thread.start();
		}

	}

	public void stopAnimate()
	{
		if (thread != null)
		{
			isRun = false;
			thread.stop();
			thread = null;
		}

	}

	public void run()
	{
		while (isRun)
		{
			nextFrame();
			observer.repaint();
			try
			{
				Thread.sleep(delay);
			} catch (InterruptedException e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

}
