package SpritesTool;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 * 
 * @author samih
 * 
 */
public class TestSprite extends JPanel
{
	Dimension offDimension;

	Image offImage;

	Graphics offGraphics;

	MediaTracker tracker;

	Image imgs[];

	String[] frames;

	Point loc;

	int speed;

	Sprite sprite = null;

	public TestSprite(int num, String folder)
	{
		tracker = new MediaTracker(this);
		loc = new Point(0, 0);
		frames = new String[num];
		for (int i = 0; i < frames.length; i++)
		{
			frames[i] = ".\\" + folder + "\\" + (i + 1) + ".png";
		}

		this.addKeyListener(new KeyLis());
		setFocusable(true);
		setSize(500, 500);

	}

	public void paint(Graphics g)
	{
		// update(g);
		Dimension d = getSize();
		// Create the offscreen graphics context
		if ((offGraphics == null) || (d.width != offDimension.width)
				|| (d.height != offDimension.height))
		{
			System.out.println("update if offGraphics");
			offDimension = d;
			offImage = createVolatileImage(d.width, d.height);
			offGraphics = offImage.getGraphics();
			if (sprite == null)
			{
				sprite = new Sprite(frames, (Graphics2D) offGraphics, this,
						loc.x, loc.y);

			}
		}

		// Erase the previous image
		offGraphics.setColor(getBackground());
		offGraphics.fillRect(0, 0, d.width, d.height);
		sprite.drawCurrentSprite();
		g.drawImage(offImage, 0, 0, null);
	}

	public class KeyLis implements KeyListener
	{

		public void keyTyped(KeyEvent e)
		{
		}

		public void keyPressed(KeyEvent e)
		{

			System.out.println("Pressed");

			// Check the shift key, and do 10x the movement if the
			// shift key is down when the arrow keys are pressed.
			// Altho keyPressed is called for normal characters, they
			// are ignored here and handled in keyTyped.
			if (e.isShiftDown())
			{
				speed = 10;
			} else
			{
				speed = 2;
			}

			// -- Process arrow "virtual" keys
			switch (e.getKeyCode())
			{
			case KeyEvent.VK_LEFT:
				loc.x -= speed;
				loc.x = Math.max(loc.x, 0);
				sprite.stopAnimate();
				break;
			case KeyEvent.VK_RIGHT:
				loc.x += speed;
				loc.x = Math.min(loc.x, TestSprite.this.getSize().width);
				sprite.animate(100);
				break;
			case KeyEvent.VK_UP:
				loc.y -= speed;
				loc.y = Math.max(loc.y, 0);
				break;
			case KeyEvent.VK_DOWN:
				loc.y += speed;
				loc.y = Math.min(loc.y, TestSprite.this.getSize().height);
				break;
			}

			speed = 2; // Restore speed to its default value
			// sprite.nextFrame();
			// sprite.nextFrame();
			sprite.setLocation(loc.x, loc.y);
			// repaint(); // Display the changes.
		}// endmethod keyPressed

		public void keyReleased(KeyEvent e)
		{
		}
	}

	public static void main(String[] args)
	{
		TestSprite p = new TestSprite(5, "s2");

		JFrame f = new JFrame();
		f.add(p);
		f.setSize(500, 500);
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		f.setVisible(true);

	}

}
